132 Commits
Author SHA1 Message Date
jbussdieker a294b34e57 Update VERSION
Bump version for FreeBSD support
2012-11-27 14:05:23 -08:00
jbussdieker 57c4a9eea7 Merge pull request #17 from matttproud/feature/decouple-shell-path-for-freebsd
Provide support for FreeBSD.
2012-11-27 14:00:28 -08:00
Matt T. Proud 4e117a3ab8 Provide support for FreeBSD.
FreeBSD does not by default install the Bourne-Again Shell (bash); and
when it is installed, it is most certainly not installed to
``/bin/bash`` due to the nuances of the conventions around local site
packages.  Rather, it is installed to ``/usr/local/bin/bash``.

Golang explicitly supports FreeBSD, so it should only be reasonable for
GVM to support this target, too.  As a fix, the shell script shebang
definitions now use the ``env`` tool that comes from the _coreutils_
standard package, which is installed on all conventions-adhering Linux
distributions, Mac OS X, and FreeBSD.

FreeBSD prerequisites are now listed in the documentation.

I have tested this against FreeBSD 9.0 release branch on the amd64,
and it works satisfactorily now.
2012-11-18 20:10:59 +01:00
Manoj Dayaram b0ffc5c3c5 Making version var local so as to not conflict with any global version vars when executing gvm use 2012-09-20 15:08:18 -07:00
jbussdieker 71774a44ba Merge pull request #16 from fd/master
Aliasing support
2012-09-20 13:29:28 -07:00
Simon Menke 5c78e3b5c5 Adding the alias command 2012-09-20 22:06:42 +02:00
Simon Menke d6c46161ee Allow using a different SRC_REPO while installing GVM 2012-09-20 18:36:12 +02:00
jbussdieker 2dbe743a6f Update README.md 2012-08-17 01:39:51 -07:00
jbussdieker 07211ed306 Update README.md 2012-08-17 01:38:32 -07:00
Joshua Bussdieker 99579e9ada Fix bug with gvm completion script 2012-07-21 03:04:48 -07:00
Joshua Bussdieker 0eb9feb2aa Better error output when trying to 'gvm use' a version that
isn't installed. Fixes issue #15
2012-07-18 12:28:58 -07:00
Joshua Bussdieker 292e24e1ea Mostly working gnu install process 2012-04-06 04:20:11 -07:00
Joshua Bussdieker 42f23a42db Update authors and changelog 2012-04-06 04:07:44 -07:00
Joshua Bussdieker 96fae148f2 Update automake file 2012-04-06 04:04:42 -07:00
Joshua Bussdieker 2743e8a8a3 More gnu work 2012-04-06 03:40:45 -07:00
Joshua Bussdieker b050317920 Adding autogen script 2012-04-06 03:21:44 -07:00
Joshua Bussdieker e3d8ab9342 Work on gnu scripts 2012-04-06 03:19:43 -07:00
Joshua Bussdieker cb40ec511a Adding gnu build files 2012-04-06 03:15:45 -07:00
Joshua Bussdieker 004a4be87a Cleanup messages and add more error handling 2012-04-06 01:32:08 -07:00
Joshua Bussdieker 4429234d51 This needs to happen first 2012-04-06 01:15:49 -07:00
Joshua Bussdieker ee8f6bd7c8 Use tool locations from functions 2012-04-06 01:13:22 -07:00
Joshua Bussdieker 718f239a6c Add cross compile helper 2012-04-06 01:11:53 -07:00
Joshua Bussdieker 8db8d28e03 Adding newline to end. This is even more important than formatting. 2012-04-01 17:16:23 -07:00
Joshua Bussdieker 4ffe88c552 Merge branch 'master' of github.com:moovweb/gvm 2012-04-01 17:14:52 -07:00
Joshua Bussdieker 5b4da7cd20 Need tput and TERM=xterm for color. This fixes calling scripts from gedit. 2012-04-01 17:14:11 -07:00
Hampton Catlin 225515360d I just did the most important thing about a license, I formatted it 2012-03-29 09:12:11 -07:00
Hampton Catlin 96702949d7 adding in license 2012-03-29 09:11:03 -07:00
Joshua Bussdieker ba20d967e0 Major cleanup of install script. Default is now clean install. 2012-03-28 23:43:54 -07:00
Joshua Bussdieker b44a14bb35 Fix match for go current go version 2012-03-28 23:21:33 -07:00
Joshua Bussdieker 06d266197d Add warning if protoc isn't found when installing a Go version
with protocol buffer support
2012-03-28 22:56:53 -07:00
Joshua Bussdieker 0cc983dec8 Fix error and dependency checking 2012-03-28 22:03:40 -07:00
Joshua Bussdieker 5b7c7d708b Check for tput 2012-03-28 21:52:52 -07:00
Joshua Bussdieker 611925e4e7 Update README for Go1 2012-03-28 11:24:21 -07:00
Joshua Bussdieker 33c8fb5a38 Merge branch 'master' of https://github.com/moovweb/gvm 2012-03-28 11:01:18 -07:00
Joshua Bussdieker f57677b96a List go1 versions in gvm listall 2012-03-28 11:00:37 -07:00
Joshua Bussdieker 86af98f0af Merge branch 'master' of github.com:moovweb/gvm 2012-03-27 22:48:35 -07:00
Joshua Bussdieker 54df5d9ccd display_error no longer exits so it's safe to use when running
in the source environment. Also catch tool errors in the gvm script
and function.
2012-03-27 22:48:02 -07:00
Joshua Bussdieker 37e9eef1f0 More logger like 2012-03-27 22:45:03 -07:00
Joshua Bussdieker 252fcee6bd Start working on DEBIAN control file for packaging. 2012-03-26 16:38:31 -07:00
Joshua Bussdieker 895f00603b Revert "provide cleaner output where tput doesn't exist"
This reverts commit a3bd04c4c9.
2012-03-25 10:32:30 -07:00
jbussdieker d1b5a1721b Merge pull request #10 from handcraftsman/master
provide cleaner output where tput doesn't exist
2012-03-25 09:19:09 -07:00
Clinton Sheppard a3bd04c4c9 provide cleaner output where tput doesn't exist
e.g. msysgit - Git for Windows
2012-03-25 08:48:24 -05:00
Joshua Bussdieker aece4141b7 Missed a reference 2012-03-24 05:13:58 -07:00
Joshua Bussdieker 0f111283cc Merge branch 'master' of github.com:moovweb/gvm
Conflicts:
	scripts/diff
	scripts/templates/binary
2012-03-24 05:00:40 -07:00
Joshua Bussdieker 00ca5e9ce1 Get the clean path to common posix tools used by GVM 2012-03-24 04:57:24 -07:00
Joshua Bussdieker 42b539cadb Merge branch 'master' of https://github.com/moovweb/gvm
Conflicts:
	scripts/diff
2012-03-23 10:14:28 -07:00
Joshua Bussdieker 30e0fc52df Make zsh compatible 2012-03-23 10:11:51 -07:00
Joshua Bussdieker e5d5641e31 Bump version 2012-03-22 22:10:54 -07:00
Joshua Bussdieker 52a6e4afc9 Merge branch 'master' of github.com:moovweb/gvm 2012-03-22 22:09:30 -07:00
Joshua Bussdieker 3a5813784e Find the system ls command and use it to fix issue #6 2012-03-22 22:09:05 -07:00
Hampton Catlin 12b1d1a254 adding in joshs credit 2012-03-22 13:18:00 -07:00
Joshua Bussdieker be751c7d69 Bump version 2012-03-20 05:43:25 -07:00
Joshua Bussdieker 68c0ffdf9e Don't know how this got deleted 2012-03-20 05:39:50 -07:00
Joshua Bussdieker 469bd7c81c Cleanup system package install 2012-03-20 05:36:27 -07:00
Joshua Bussdieker a9640b0bbc Better error messages 2012-03-20 03:16:32 -07:00
Joshua Bussdieker aec0080464 Check for git before install 2012-03-20 03:00:40 -07:00
Joshua Bussdieker 13ef2e1f19 Bump version 2012-03-20 01:03:26 -07:00
Joshua Bussdieker 03ae59f0ff Detect existing versions of Go 2012-03-20 01:01:00 -07:00
Joshua Bussdieker bc2ef7ba41 Fix bug in pb option 2012-03-19 22:05:49 -07:00
Joshua Bussdieker a28c8f220e Use display_warning function 2012-03-19 21:51:54 -07:00
Joshua Bussdieker 6bbf1f3bb5 Safer strings 2012-03-19 21:44:39 -07:00
Joshua Bussdieker 55ae6dd774 Make protocol buffer support optional 2012-03-19 21:44:14 -07:00
Joshua Bussdieker 4558bd0b53 That's a bug if I've ever seen one! 2012-03-19 21:09:25 -07:00
Joshua Bussdieker f0e3956030 Bump version 2012-03-19 20:37:52 -07:00
Joshua Bussdieker e3246cef0d Match gpkg help format 2012-03-19 20:36:05 -07:00
Joshua Bussdieker 4359f5252f Fix path bug and add back config 2012-03-18 11:13:41 -07:00
jbussdieker e8076a83fb Merge pull request #4 from hoisie/master
Use HTTPS instead of SSH when downloading the git repo
2012-03-17 16:49:47 -07:00
Michael Hoisie bc1fc149f3 Use HTTP instead of SSH to access the git repo. Some firewalls block port port 9418 (the defailt for git ssh) 2012-03-17 14:23:12 -07:00
Joshua Bussdieker 6e8720de05 Bumping version 2012-03-17 06:58:43 -07:00
Joshua Bussdieker 0cae267942 Update source 2012-03-17 06:56:41 -07:00
Joshua Bussdieker 578436bb4e Update help and remove more gvm pkg artifacts 2012-03-14 04:42:37 -07:00
Joshua Bussdieker 97ed989f6a Long term release 2012-03-14 03:39:09 -07:00
Joshua Bussdieker 413af34098 Fix output bug 2012-03-14 03:35:00 -07:00
Joshua Bussdieker 31403a1024 Leftover from gvm pkg 2012-03-14 03:33:05 -07:00
Joshua Bussdieker 36c74ada3f Display install location 2012-03-14 03:26:18 -07:00
Joshua Bussdieker 28e9e0cd8b Update install script 2012-03-14 03:25:13 -07:00
Joshua Bussdieker d10899c1a4 Install any branch 2012-03-14 02:43:50 -07:00
Joshua Bussdieker 60b04451a3 master will now be stable. dev will be done in unstable branch 2012-03-14 02:40:58 -07:00
jbussdieker 8a65c2d001 Update README.md 2012-03-14 01:29:58 -07:00
jbussdieker eabc181127 Update README.md 2012-03-07 23:18:39 -08:00
Joshua Bussdieker 79b475b3c4 Fix indentation. Prefer .profile over .bashrc 2012-03-07 02:24:57 -08:00
Joshua Bussdieker de99e332ac Merge branch 'master' of github.com:moovweb/gvm 2012-03-07 02:19:08 -08:00
Joshua Bussdieker 043e6a44f7 Fixed profile install issue 2012-03-07 02:18:55 -08:00
jbussdieker 2b3fb6da35 Update README.md 2012-03-07 02:11:24 -08:00
Joshua Bussdieker a3da2239c9 Merge branch 'master' of github.com:moovweb/gvm 2012-03-07 01:40:14 -08:00
Joshua Bussdieker e02f21ed01 Fix pkgset list bug 2012-03-07 01:38:54 -08:00
jbussdieker 7237f663fd Update README.md 2012-03-05 04:33:34 -08:00
jbussdieker 218d322710 Update README.md 2012-03-05 04:11:47 -08:00
Joshua Bussdieker 0b7eeb4a3d 0.0.9 now in dev 2012-03-05 03:57:55 -08:00
Joshua Bussdieker 595531b7fc Taken over by gpkg 2012-03-04 22:54:05 -08:00
Joshua Bussdieker 85db8304cc Safety feature 2012-03-04 22:09:41 -08:00
Joshua Bussdieker de9ceccb78 More message cleanup 2012-03-04 18:01:08 -08:00
Joshua Bussdieker 4933d13418 Fix tabs. Can now gvm pkgset use blah --default 2012-03-04 17:34:37 -08:00
Joshua Bussdieker 9e1c0b67de Use message function 2012-03-04 17:28:47 -08:00
Joshua Bussdieker 6e720f80c1 Fix tabs 2012-03-04 17:28:35 -08:00
Joshua Bussdieker 5ef8b40fa8 Better error handling in uninstall script 2012-03-04 17:24:11 -08:00
Joshua Bussdieker 3a45cde1aa Make template Mac compatible 2012-03-02 19:15:25 -08:00
Joshua Bussdieker bdc0eb2fda More pkg install improvements 2012-03-02 19:02:51 -08:00
Joshua Bussdieker 2f562e6d3c Template for installed binaries 2012-03-02 19:02:37 -08:00
Joshua Bussdieker 99f4c5035c Fix pkg install 2012-03-02 17:52:08 -08:00
Joshua Bussdieker 503ec01aaa Added gvm update to download updateds to the Go source 2012-03-02 01:31:00 -08:00
Joshua Bussdieker d4fa2d8bdb Cleanup Go install script. 2012-03-02 01:30:51 -08:00
Joshua Bussdieker 9711c445d8 Skip tests for now... 2012-03-02 01:30:43 -08:00
Joshua Bussdieker 6d5e3ec8d5 These will be replaced with gpkg 2012-03-01 23:27:41 -08:00
Joshua Bussdieker 1b5197c450 Bump again 2012-03-01 23:27:16 -08:00
Joshua Bussdieker c1e449309b New 0.0.7 stable 2012-03-01 23:23:40 -08:00
Joshua Bussdieker d46e351d9e Not in stable 2012-03-01 23:21:18 -08:00
Joshua Bussdieker 8fe98115fe Revert to stable on these 2012-03-01 23:20:46 -08:00
Joshua Bussdieker cc1715379c Remove debug line 2012-03-01 23:13:34 -08:00
Joshua Bussdieker 967104cad7 Add command line parameters 2012-03-01 23:08:51 -08:00
Joshua Bussdieker fc5db824bf Fix pkgset use bug 2012-03-01 23:08:08 -08:00
Joshua Bussdieker 562c90dee3 Remove test file 2012-03-01 22:46:24 -08:00
Joshua Bussdieker 1ad33a27b7 Fix path bug 2012-03-01 22:43:48 -08:00
Joshua Bussdieker 6cb227b098 Doh! 2012-03-01 22:18:56 -08:00
Joshua Bussdieker 6c677cf349 More detail 2012-03-01 22:17:00 -08:00
Joshua Bussdieker a846b2b613 Make executable 2012-03-01 22:14:55 -08:00
Joshua Bussdieker 8ec660e76c Add version test 2012-03-01 22:13:38 -08:00
Joshua Bussdieker d7f0b47e17 Fix test mode 2012-03-01 22:05:42 -08:00
Joshua Bussdieker 081f7ea235 Adding test mode 2012-03-01 22:00:47 -08:00
Joshua Bussdieker dd4d21df14 Moved gpkg to seperate repo 2012-03-01 21:36:27 -08:00
Joshua Bussdieker b4d148ed9a Now generates Makefiles! 2012-03-01 17:00:50 -08:00
Joshua Bussdieker 3102c3bab5 Read import info too 2012-03-01 14:23:09 -08:00
Joshua Bussdieker e80e9af547 Testing installer via goinstall 2012-03-01 00:33:55 -08:00
jbussdieker 9bdba4e258 Update README.md 2012-03-01 00:07:22 -08:00
Joshua Bussdieker c33216e4d3 Package install madness!!! 2012-02-29 23:48:19 -08:00
Joshua Bussdieker 2b731381b6 These errors are okay 2012-02-29 23:47:57 -08:00
Joshua Bussdieker 5c31a8e593 List goinstalled packages too 2012-02-29 21:46:28 -08:00
Joshua Bussdieker 62c9513954 Merge branch 'master' of github.com:moovweb/gvm 2012-02-29 21:36:35 -08:00
Joshua Bussdieker 8480e63c86 Update gitignores. Add gpkg/pkgs module. 2012-02-29 21:35:47 -08:00
Joshua Bussdieker 4f0d8e3c5e Updated gpkg main 2012-02-29 21:33:28 -08:00
Joshua Bussdieker e1c6da6bc9 Use display message for gvm pkg list 2012-02-29 21:32:15 -08:00
Joshua Bussdieker e3192d58c5 Fix tabs 2012-02-29 20:40:54 -08:00
56 changed files with 777 additions and 621 deletions
-1
View File
@@ -1,7 +1,6 @@
*~
go
gos/
pkgs
pkgsets/
archive/
environments/
+1
View File
@@ -0,0 +1 @@
Joshua Bussdieker <josh.bussdieker@moovweb.com>
+14 -2
View File
@@ -1,7 +1,19 @@
Version: 0.0.8
State: Development
Fri Apr 6 04:06:29 PDT 2012 Joshua Bussdieker <jbussdieker@gmail.com>
* Created automake template
Version: 1.0.x
State: LTR
CHANGES:
* Minor bug fixes and cleanup. 1.0.x will always be a safe upgrade path.
Version: 0.0.8
State: Stable
CHANGES:
* Complete overhaul of the package system. Now uses
http://github.com/moovweb/gpkg
Version: 0.0.7
State: Stable
+19
View File
@@ -0,0 +1,19 @@
Copyright (C) 2012 Moov Corp.
Permission is hereby granted, free of charge, to any person obtaining
a copy of this software and associated documentation files (the "Software"),
to deal in the Software without restriction, including without limitation
the rights to use, copy, modify, merge, publish, distribute, sublicense,
and/or sell copies of the Software, and to permit persons to whom the
Software is furnished to do so, subject to the following conditions:
The above copyright notice and this permission notice shall be included
in all copies or substantial portions of the Software.
THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
DEALINGS IN THE SOFTWARE.
+13
View File
@@ -0,0 +1,13 @@
EXTRA_INSTALL = scripts/
gvmdir = $(bindir)/
gvm_SCRIPTS = bin/gvm
install_dir = $(prefix)/gvm
install-exec-hook:
(mkdir -p $(install_dir) ; \
cp -rf . $(install_dir))
#install-data-hook:
# (mkdir -p $(help_dir) ; \
# cp -f *_help.txt $(help_dir))
View File
+72
View File
@@ -0,0 +1,72 @@
# gvm
by Josh Bussdieker (jbuss, jaja, jbussdieker)
GVM provides an interface to manage Go versions.
Features
========
* Install/Uninstall Go versions with `gvm install [tag]` where tag is "60.3", "go1", "weekly.2011-11-08", or "tip"
* List added/removed files in GOROOT with `gvm diff`
* Manage GOPATHs with `gvm pkgset [create/use/delete] [name]`
* List latest release tags with `gvm listall`. Use `--all` to list weekly as well.
* Cache a clean copy of the latest Go source for multiple version installs.
Background
==========
When we started developing in Go mismatched dependencies and API changes plauged our build process and made it extremely difficult to merge with other peoples changes.
After nuking my entire GOROOT several times and rebuilding I decided to come up with a tool to oversee the process. It eventually evolved into what gvm is today.
Installing
==========
To install:
bash < <(curl -s https://raw.github.com/moovweb/gvm/master/binscripts/gvm-installer)
Installing Go
=============
gvm install go1
gvm use go1 [--default]
Once this is done Go will be in the path and ready to use. $GOROOT and $GOPATH are set automatically.
You are now ready to create and use packages built using gpkg. Instructions can be found at http://github.com/moovweb/gpkg
List Go Versions
================
To list all installed Go versions (The current version is prefixed with "=>"):
gvm list
Uninstalling
============
To completely remove gvm and all installed Go versions and packages:
gvm implode
If that doesn't work see the troubleshooting steps at the bottom of this page.
Mac OS X Requirements
====================
Install mercurial from http://mercurial.berkwood.com/
Linux Requirements
==================
sudo apt-get install curl
sudo apt-get install git
sudo apt-get install mercurial
sudo apt-get install make
sudo apt-get install binutils
sudo apt-get install bison
sudo apt-get install gcc
FreeBSD Requirements
====================
sudo pkg_add -r bash
sudo pkg_add -r git
sudo pkg_add -r mercurial
Troubleshooting
===============
Sometimes especially during upgrades the state of gvm's files can get mixed up. This is mostly true for upgrade from older version than 0.0.8. Changes are slowing down and a LTR is imminent. But for now `rm -rf ~/.gvm` will always remove gvm. Stay tuned!
+31 -16
View File
@@ -1,26 +1,34 @@
# gvm
by Josh Bussdieker (jbuss, jaja, jbussdieker)
GVM provides an interface to manage Go versions.
Features
========
* Install/Uninstall Go versions with `gvm install [tag]` where tag is "60.3", "go1", "weekly.2011-11-08", or "tip"
* List added/removed files in GOROOT with `gvm diff`
* Manage GOPATHs with `gvm pkgset [create/use/delete] [name]`
* List latest release tags with `gvm listall`. Use `--all` to list weekly as well.
* Cache a clean copy of the latest Go source for multiple version installs.
Background
==========
When we started developing in Go mismatched dependencies and API changes plauged our build process and made it extremely difficult to merge with other peoples changes.
After nuking my entire GOROOT several times and rebuilding I decided to come up with a tool to oversee the process. It eventually evolved into what gvm is today.
Installing
==========
To install the stable release run:
bash -s stable < <(curl -s https://raw.github.com/moovweb/gvm/master/binscripts/gvm-installer)
To install the development branch (NOT USUALLY RECOMMENDED!) run:
To install:
bash < <(curl -s https://raw.github.com/moovweb/gvm/master/binscripts/gvm-installer)
Protect Your GO!
================
sudo chown -R root:root ~/.gvm/gos/
This will keep libraries from accidentally installing into the main Go soure tree
Installing Go
=============
gvm install 60.3
gvm use 60.3
Once this is done Go will be in the path and ready to use. $GOROOT is set automatically.
gvm install go1
gvm use go1 [--default]
Once this is done Go will be in the path and ready to use. $GOROOT and $GOPATH are set automatically.
List Go Versions
================
@@ -34,7 +42,7 @@ To completely remove gvm and all installed Go versions and packages:
gvm implode
Mac OSX Requirements
Mac OS X Requirements
====================
Install mercurial from http://mercurial.berkwood.com/
@@ -48,3 +56,10 @@ Linux Requirements
sudo apt-get install bison
sudo apt-get install gcc
FreeBSD Requirements
====================
sudo pkg_add -r bash
sudo pkg_add -r git
sudo pkg_add -r mercurial
+1 -1
View File
@@ -1 +1 @@
0.0.8-dev
1.0.16
Executable
+1
View File
@@ -0,0 +1 @@
aclocal && automake --add-missing && autoconf && ./configure $@
+14 -18
View File
@@ -1,4 +1,4 @@
#!/bin/bash
#!/usr/bin/env bash
if [ -z "$GVM_ROOT" ]; then
tput sgr0
tput setaf 1
@@ -10,7 +10,7 @@ if [ -z "$GVM_ROOT" ]; then
exit 1
fi
. $GVM_ROOT/scripts/functions
. $GVM_ROOT/scripts/functions || exit 1
command=$1
if [[ $command == "implode" ]]; then
@@ -20,40 +20,36 @@ fi
$GVM_ROOT/scripts/gvm-check
if [[ "$?" != "0" ]]; then
display_error "Missing requirements. Please see messages above"
display_fatal "Missing requirements."
fi
if [[ $command == "version" ]]; then
display_message "Go Version Manager v$GVM_VERSION"
display_message "Go Version Manager v$GVM_VERSION installed at $GVM_ROOT"
else
if [ -f $GVM_ROOT/scripts/$command ]; then
shift
$GVM_ROOT/scripts/$command $@
elif [[ -n $command ]]; then
display_error "Unrecognized command line argument: '$command'"
display_fatal "Unrecognized command line argument: '$command'"
else
echo "= gvm
echo "Usage: gvm [command]
* http://github.com/moovweb/gvm
== DESCRIPTION:
GVM is the Go Version Manager
== Usage
gvm Command
== Command
Description:
GVM is the Go Version Manager
Commands:
version - print the gvm version number
get - gets the latest code (for debugging)
use - select a go version to use
diff - view changes to Go root
implode - completely remove gvm
install - install go versions
uninstall - uninstall go versions
cross - install go cross compilers
list - list installed go versions
listall - list available versions
alias - manage go version aliases
pkgset - manage go packages sets
pkg - manage go packages"
"
fi
fi
+1 -1
View File
@@ -1,4 +1,4 @@
#!/bin/bash
#!/usr/bin/env bash
function gvm_prompt() {
if [[ "$1" == "g" ]]; then
echo $gvm_go_name
-6
View File
@@ -1,6 +0,0 @@
if [[ -f Makefile.gvm ]]; then
make -f Makefile.gvm $@
else
gb -bi
fi
+76 -36
View File
@@ -1,4 +1,4 @@
#!/bin/bash
#!/usr/bin/env bash
display_error() {
tput sgr0
tput setaf 1
@@ -7,55 +7,95 @@ display_error() {
exit 1
}
update_profile() {
[ -f $1 ] || return 1
cat $1 | grep "$source_line" > /dev/null 2>&1
if [ $? -ne 0 ]; then
echo "$source_line" >> $1
fi
}
check_existing_go() {
if [ "$GOROOT" == "" ]; then
echo "No existing Go versions detected"
return
fi
echo "Created profile for existing install of Go at $GOROOT"
mkdir -p $GVM_DEST/$GVM_NAME/environments &> /dev/null || display_error "Failed to create environment directory"
mkdir -p $GVM_DEST/$GVM_NAME/pkgsets/system/global &> /dev/null || display_error "Failed to create new package set"
mkdir -p $GVM_DEST/$GVM_NAME/gos/system &> /dev/null || display_error "Failed to create new Go folder"
cat << EOF > $GVM_DEST/$GVM_NAME/environments/system
# Automatically generated file. DO NOT EDIT!
export GVM_ROOT; GVM_ROOT="$GVM_DEST/$GVM_NAME"
export gvm_go_name; gvm_go_name="system"
export gvm_pkgset_name; gvm_pkgset_name="global"
export GOROOT; GOROOT="$GOROOT"
export GOPATH; GOPATH="$GVM_DEST/$GVM_NAME/pkgsets/system/global"
export PATH; PATH="$GVM_DEST/$GVM_NAME/pkgsets/system/global:$GOROOT/bin:$GVM_ROOT/bin:\$PATH"
EOF
}
BRANCH=$1
if [ "$(whoami)" != "root" ]; then
GVM_DEST=~
GVM_NAME=.gvm
GVM_DEST=$2
if [ "$GVM_DEST" == "" ]; then
GVM_DEST="$HOME"
GVM_NAME=".gvm"
else
GVM_DEST=/usr/local
GVM_NAME=gvm
GVM_NAME="gvm"
fi
ENV_FILE=~/.bashrc
SRC_REPO=git://github.com/moovweb/gvm.git
#SRC_REPO=~/install.gvm
if [ "$SRC_REPO" == "" ]; then
SRC_REPO=https://github.com/moovweb/gvm.git
fi
[ "$GVM_DEST" == "" ] && display_error "No destination specified!"
[ -d $GVM_DEST/$GVM_NAME ] && display_error "Already installed!"
[ -d $GVM_DEST ] || mkdir -p $GVM_DEST > /dev/null 2>&1 || display_error "Failed to create $GVM_DEST"
[ -z `which git` ] && display_error "Could not find git
cd $GVM_DEST && git clone $SRC_REPO $GVM_NAME > /dev/null 2>&1 ||
linux: apt-get install git
mac: brew install git
"
cd $GVM_DEST && git clone $SRC_REPO $GVM_NAME > /dev/null 2>&1 ||
display_error "Failed to clone from $SRC_REPO into $GVM_DEST/$GVM_NAME"
if [ "$BRANCH" == "stable" ]; then
cd $GVM_DEST/$GVM_NAME && git checkout $BRANCH > /dev/null 2>&1 ||
display_error "Failed to checkout $BRANCH branch"
if [ "$BRANCH" != "" ]; then
cd $GVM_DEST/$GVM_NAME && git checkout $BRANCH > /dev/null 2>&1 ||
display_error "Failed to checkout $BRANCH branch"
fi
mv $GVM_DEST/$GVM_NAME/.git $GVM_DEST/$GVM_NAME/git.bak
if [ "$(whoami)" != "root" ]; then
if [ -e ~/.bashrc ]; then
cat ~/.bashrc | grep "\[\[ -s \"\$HOME/.gvm/scripts/gvm\" ]] && source \"\$HOME/.gvm/scripts/gvm\"" > /dev/null 2>&1
if [ $? -ne 0 ]; then
echo '[[ -s "$HOME/.gvm/scripts/gvm" ]] && source "$HOME/.gvm/scripts/gvm"' >> $ENV_FILE
fi
elif [ -e ~/.profile ]; then
cat ~/.bashrc | grep "\[\[ -s \"\$HOME/.gvm/scripts/gvm\" ]] && source \"\$HOME/.gvm/scripts/gvm\"" > /dev/null 2>&1
if [ $? -ne 0 ]; then
echo '[[ -s "$HOME/.gvm/scripts/gvm" ]] && source "$HOME/.gvm/scripts/gvm"' >> $ENV_FILE
fi
else
echo 'Unable to location profile settings file'
echo
echo " You will have to manually add the following line:"
echo " [[ -s \"\$HOME/.gvm/scripts/gvm\" ]] && source \"\$HOME/.gvm/scripts/gvm\""
echo
echo "To get started right away run \`source ~/.gvm/scripts/gvm\`"
echo
fi
if [ "$GVM_NAME" == ".gvm" ]; then
source_line="[[ -s \"\$HOME/.gvm/scripts/gvm\" ]] && source \"\$HOME/.gvm/scripts/gvm\""
source_file="\$HOME/.gvm/scripts/gvm"
else
source_line="[[ -s \"${GVM_DEST}/gvm/scripts/gvm\" ]] && source \"${GVM_DEST}/gvm/scripts/gvm\""
source_file="${GVM_DEST}/gvm/scripts/gvm"
fi
if [ "`uname`" == "Linux" ]; then
update_profile $HOME/.bashrc || update_profile $HOME/.bash_profile
elif [ "`uname`" == "Darwin" ]; then
update_profile $HOME/.profile || update_profile $HOME/.bash_profile
fi
if [ "$?" != "0" ]; then
echo 'Unable to locate profile settings file'
echo
echo " You will have to manually add the following line:"
echo
echo " $source_line"
echo
fi
echo "export GVM_ROOT=$GVM_DEST/$GVM_NAME" > $GVM_DEST/$GVM_NAME/scripts/gvm
echo ". \$GVM_ROOT/scripts/gvm-default" >> $GVM_DEST/$GVM_NAME/scripts/gvm
check_existing_go
[[ -s "$GVM_DEST/$GVM_NAME/scripts/gvm" ]] && source "$GVM_DEST/$GVM_NAME/scripts/gvm"
echo "Installed GVM v$GVM_VERSION"
echo "Please restart your terminal session"
echo "Installed GVM v${GVM_VERSION}"
echo
echo "Please restart your terminal session or to get started right away run"
echo " \`source ${source_file}\`"
echo
+1 -1
View File
@@ -1 +1 @@
git@github.com:moovweb
git://github.com/moovweb
+4
View File
@@ -0,0 +1,4 @@
AC_INIT(gvm, m4_esyscmd([tr -d '\n' <VERSION]))
AM_INIT_AUTOMAKE
AC_CONFIG_FILES([Makefile scripts/gvm])
AC_OUTPUT
+5
View File
@@ -0,0 +1,5 @@
Package: gvm
Version: 1.0.15
Architecture: all
Maintainer: Joshua Bussdieker <josh.bussdieker@moovweb.com>
Description: Go Version Manager
-12
View File
@@ -1,12 +0,0 @@
package main
import "os"
func main() {
gvm_root := os.Getenv("GVM_ROOT")
if gvm_root == "" {
println("ERROR: gpkg requires gvm to run (http://github.com/moovweb/gvm)")
} else {
println("GVM Package Manager!")
}
}
Executable
+29
View File
@@ -0,0 +1,29 @@
#!/usr/bin/env bash
. $GVM_ROOT/scripts/functions
command=$1
if [[ -f $GVM_ROOT/scripts/alias-$command ]]; then
shift
$GVM_ROOT/scripts/alias-$command $@
elif [[ -n $command ]]; then
display_fatal "Unrecognized command line argument: '$command'"
else
echo "= gvm alias
* http://github.com/moovweb/gvm
== DESCRIPTION:
GVM alias is used to manage go version aliases
== Usage
gvm alias Command
== Command
create - create a new alias
delete - delete an alias
list - list aliases"
fi
+23
View File
@@ -0,0 +1,23 @@
#!/usr/bin/env bash
. $GVM_ROOT/scripts/functions
[[ $1 != "" ]] ||
display_fatal "Please specifiy the alias name"
[[ $2 != "" ]] ||
display_fatal "Please specifiy the go version name"
[[ ! -f "$GVM_ROOT/environments/$1" ]] ||
display_fatal "Alias already exists!"
[[ -f "$GVM_ROOT/environments/$2" ]] ||
display_fatal "Target doesn't exist!"
mkdir -p $GVM_ROOT/environments ||
display_fatal "Could not create folder"
mkdir -p $GVM_ROOT/gos/$1 ||
display_fatal "Could not create folder"
cp $GVM_ROOT/environments/$2 $GVM_ROOT/environments/$1 ||
display_fatal "Could copy environment"
echo "export gvm_alias_name=\"$1\"" >> $GVM_ROOT/environments/$1 ||
display_fatal "Could not extend environment"
+18
View File
@@ -0,0 +1,18 @@
#!/usr/bin/env bash
. $GVM_ROOT/scripts/functions
[[ $1 != "" ]] ||
display_fatal "Please specifiy the name"
[[ -f $GVM_ROOT/environments/$1 ]] ||
display_fatal "Alias doesn't exist!"
cat $GVM_ROOT/environments/$1 | $GREP_PATH "gvm_alias_name" > /dev/null ||
display_fatal "$1 is not an alias!"
rm -rf $GVM_ROOT/environments/$1 ||
display_fatal "Could not delete alias"
rm -rf $GVM_ROOT/gos/$1 ||
display_fatal "Could not delete alias"
+13
View File
@@ -0,0 +1,13 @@
#!/usr/bin/env bash
. $GVM_ROOT/scripts/functions
echo
display_message "gvm go aliases"
echo
for a in $(cd $GVM_ROOT/environments ; grep -l "gvm_alias_name" *); do
t=$(sh -c ". $GVM_ROOT/environments/$a ; echo \$gvm_go_name")
echo " $a ($t)"
done
echo
+7 -5
View File
@@ -1,3 +1,5 @@
. $GVM_ROOT/scripts/functions
_gvm()
{
local cur prev opts base
@@ -13,7 +15,7 @@ _gvm()
use|delete|empty)
[[ "$gvm_go_name" == "" ]] && return 1
[[ $COMP_CWORD > 3 ]] && return 1
local version=$(for x in `ls $GVM_ROOT/pkgsets/$gvm_go_name`; do echo ${x} ; done )
local version=$(for x in `$LS_PATH $GVM_ROOT/pkgsets/$gvm_go_name`; do echo ${x} ; done )
COMPREPLY=( $(compgen -W "${version}" -- ${cur}) )
return 0
;;
@@ -33,11 +35,11 @@ _gvm()
[[ "$gvm_go_name" == "" ]] && return 1
[[ "$gvm_pkgset_name" == "" ]] && return 1
if [[ "$COMP_CWORD" == "3" ]]; then
local version=$(for x in `ls $GVM_ROOT/pkgsets/$gvm_go_name/$gvm_pkgset_name/pkg.gvm`; do echo ${x} ; done )
local version=$(for x in `$LS_PATH $GVM_ROOT/pkgsets/$gvm_go_name/$gvm_pkgset_name/pkg.gvm`; do echo ${x} ; done )
COMPREPLY=( $(compgen -W "${version}" -- ${cur}) )
return 0
elif [[ "$COMP_CWORD" == "4" ]]; then
local version=$(for x in `ls $GVM_ROOT/pkgsets/$gvm_go_name/$gvm_pkgset_name/pkg.gvm/${COMP_WORDS[3]}`; do echo ${x} ; done )
local version=$(for x in `$LS_PATH $GVM_ROOT/pkgsets/$gvm_go_name/$gvm_pkgset_name/pkg.gvm/${COMP_WORDS[3]}`; do echo ${x} ; done )
COMPREPLY=( $(compgen -W "${version}" -- ${cur}) )
return 0
fi
@@ -56,14 +58,14 @@ _gvm()
install)
[ ! -d $GVM_ROOT/archive/go ] && return 1
[[ $COMP_CWORD > 2 ]] && return 1
local version=$(for x in `hg tags -R $GVM_ROOT/archive/go | awk '{print $1}' | grep -E "release|tip"`; do echo ${x} ; done )
local version=$(for x in `hg tags -R $GVM_ROOT/archive/go | awk '{print $1}' | $GREP_PATH -E "release|tip"`; do echo ${x} ; done )
COMPREPLY=( $(compgen -W "${version}" -- ${cur}) )
return 0
;;
use|uninstall)
[ ! -d $GVM_ROOT/gos ] && return 1
[[ $COMP_CWORD > 2 ]] && return 1
local installed_versions=$(for x in `ls $GVM_ROOT/gos`; do echo ${x} ; done )
local installed_versions=$(for x in `$LS_PATH $GVM_ROOT/gos`; do echo ${x} ; done )
COMPREPLY=( $(compgen -W "${installed_versions}" -- ${cur}) )
return 0
;;
Executable
+58
View File
@@ -0,0 +1,58 @@
#!/usr/bin/env bash
. $GVM_ROOT/scripts/functions
display_usage() {
display_message "Usage: gvm cross [os] [arch]"
display_message " os = linux/darwin/windows"
display_message " arch = amd64/386 (arm unsupported)"
}
display_list() {
echo
display_usage
echo
display_message "Installed platforms:"
echo
$LS_PATH $GOROOT/pkg | $GREP_PATH windows_ | sed 's/^/ /g'
$LS_PATH $GOROOT/pkg | $GREP_PATH darwin_ | sed 's/^/ /g'
$LS_PATH $GOROOT/pkg | $GREP_PATH linux_ | sed 's/^/ /g'
echo
exit 1
}
which go &> /dev/null || display_fatal "Only available in versions after Go 1"
[ -z "$1" ] && display_list
if [ ! -f "$GOROOT/pkg/tool/cross" ]; then
display_message "Installing x86 and x86-64 commands"
set -e
for arch in 8 6; do
for cmd in a c g l; do
go tool dist install -v cmd/$arch$cmd ||
display_fatal "Couldn't compile tool: $arch$cmd"
done
done
touch $GOROOT/pkg/tool/cross
fi
export GOOS=$1
shift
[ -z "$1" ] && display_usage && display_fatal "arch is not specified"
export GOARCH=$1
if [ ! -d "$GOROOT/pkg/${GOOS}_${GOARCH}" ]; then
display_message "Installing $GOOS $GOARCH runtime library"
if [ "$GOOS" = "windows" ]; then
export CGO_ENABLED=0
fi
cd $GOROOT/src
go tool dist install -v pkg/runtime ||
display_fatal "Couldn't compile runtime library for $GOOS $GOARCH"
go install -v -a std ||
display_fatal "Install runtime library for $GOOS $GOARCH"
else
display_message "Runtime library already installed for $GOOS $GOARCH"
fi
+8 -8
View File
@@ -1,30 +1,30 @@
#!/bin/bash
#!/usr/bin/env bash
. $GVM_ROOT/scripts/functions
version=$1
if [ "$version" != "" ]; then
fuzzy_match=`ls $GVM_ROOT/gos | sort | grep "$version" | head -n 1 | grep "$version"` ||
display_error "Invalid version $version"
fuzzy_match=`$LS_PATH $GVM_ROOT/gos | $SORT_PATH | $GREP_PATH "$version" | $HEAD_PATH -n 1 | $GREP_PATH "$version"` ||
display_fatal "Invalid version $version"
foldername=$GVM_ROOT/gos/$fuzzy_match
else
if [ "$gvm_go_name" != "" ]; then
if [[ "$gvm_go_name" != "" ]]; then
foldername=$GVM_ROOT/gos/$gvm_go_name
else
display_error "No version selected"
display_fatal "No version selected"
fi
fi
if [ -d $foldername ]; then
if [[ -d $foldername ]]; then
cd $foldername
find . > /tmp/manifest.test
diff manifest /tmp/manifest.test
if [ "$?" == "0" ]; then
if [[ "$?" == "0" ]]; then
display_message "Clean $foldername"
else
display_message "*Dirty* $foldername"
fi
else
display_error "Invalid version"
display_fatal "Invalid version"
fi
+9 -11
View File
@@ -1,17 +1,15 @@
#!/bin/bash
function display_error() {
tput sgr0
tput setaf 1
echo "ERROR: $1" >&2
tput sgr0
return 1
}
#!/usr/bin/env bash
. $GVM_ROOT/scripts/functions || return 1
function gvm() {
if [[ "$GVM_ROOT" == "" ]]; then
display_error "GVM_ROOT not set. Please source GVM_ROOT/scripts/gvm"
return $?
fi
if [[ -d $GVM_ROOT/.git ]]; then
mv $GVM_ROOT/.git $GVM_ROOT/git.bak ||
display_error "Failed to move git info out of the way"
fi
if [[ ! -d $GVM_ROOT ]]; then
display_error "GVM_ROOT does not exist. Please reinstall GVM"
return $?
@@ -23,13 +21,13 @@ function gvm() {
mkdir -p $GVM_ROOT/archive/package > /dev/null 2>&1
mkdir -p $GVM_ROOT/environments > /dev/null 2>&1
if [ "$1" == "use" ]; then
if [[ "$1" == "use" ]]; then
. $GVM_ROOT/scripts/env/use
shift
gvm_use $@
elif [ "$1" == "implode" ]; then
elif [[ "$1" == "implode" ]]; then
rm -rf $GVM_ROOT
elif [ "$1" == "pkgset" ] && [ "$2" == "use" ]; then
elif [[ "$1" == "pkgset" ]] && [[ "$2" == "use" ]]; then
. $GVM_ROOT/scripts/env/pkgset-use
shift
shift
+8 -10
View File
@@ -1,11 +1,4 @@
display_error() {
tput sgr0
tput setaf 1
echo "ERROR: $1" >&2
tput sgr0
return 1
}
#!/usr/bin/env bash
function gvm_pkgset_use() {
[[ "$1" != "" ]] ||
display_error "Please specify a package set" || return 1
@@ -13,12 +6,17 @@ function gvm_pkgset_use() {
[[ "$gvm_go_name" != "" ]] ||
display_error "No Go version selected" || return 1
fuzzy_match=`ls $GVM_ROOT/environments | sort | grep "$gvm_go_name@" | head -n 1 | grep "$1"` ||
fuzzy_match=`$LS_PATH $GVM_ROOT/environments | $SORT_PATH | $GREP_PATH "$gvm_go_name@" | $GREP_PATH "$1" | $HEAD_PATH -n 1` ||
display_error "Invalid package set" || return 1
. "$GVM_ROOT/environments/$gvm_go_name@$1" ||
export PATH=$GVM_PATH_BACKUP
. "$GVM_ROOT/environments/$fuzzy_match" ||
display_error "Failed to source the package set environment" || return 1
if [[ "$2" == "--default" ]]; then
cp $GVM_ROOT/environments/$fuzzy_match $GVM_ROOT/environments/default
fi
echo "Now using version $fuzzy_match"
}
+16 -21
View File
@@ -1,28 +1,23 @@
function display_error() {
tput sgr0
tput setaf 1
echo "ERROR: $1" >&2
tput sgr0
return 1
}
display_message() {
# GREEN!
tput sgr0
tput setaf 2
echo "$1"
tput sgr0
}
#!/usr/bin/env bash
function gvm_use() {
[[ "$1" != "" ]] ||
[[ "$1" != "" ]] ||
display_error "Please specifiy the version" || return 1
fuzzy_match=`ls $GVM_ROOT/gos | sort | grep "$1" | head -n 1 | grep "$1"` ||
display_error "Invalid version $1" || return 1
local VERSION=$1
fuzzy_match=`$LS_PATH $GVM_ROOT/gos | $SORT_PATH | $GREP_PATH "$1" | $HEAD_PATH -n 1 | $GREP_PATH "$1"`
if [[ "$?" != "0" ]]; then
GO_CACHE_PATH=$GVM_ROOT/archive/go
version=`hg tags -R $GO_CACHE_PATH | awk '{print $1}' | $SORT_PATH | $GREP_PATH "$VERSION" | $HEAD_PATH -n 1 | $GREP_PATH "$VERSION"`
if [[ "x$version" == "x" ]]; then
display_error "Version not found locally. Try 'gvm install $1'" || return 1
else
display_warning "$version is not installed. Install it by running 'gvm install $version'" || return 1
fi
fi
. $GVM_ROOT/environments/$fuzzy_match
export PATH=$GVM_PATH_BACKUP
. $GVM_ROOT/environments/$fuzzy_match &> /dev/null || display_error "Couldn't source environment" || return 1
if [[ "$2" == "--default" ]]; then
cp $GVM_ROOT/environments/$fuzzy_match $GVM_ROOT/environments/default
cp $GVM_ROOT/environments/$fuzzy_match $GVM_ROOT/environments/default || display_error "Couldn't make $fuzzy_match default"
fi
display_message "Now using version $fuzzy_match"
+10 -5
View File
@@ -1,8 +1,13 @@
display_error() {
tput sgr0
tput setaf 1
echo "ERROR: $1" >&2
tput sgr0
exit 1
which tput &> /dev/null
if [[ "$?" == "0" ]] && [[ "$TERM" == "xterm" ]]; then
tput sgr0
tput setaf 1
echo "ERROR: $1" >&2
tput sgr0
else
echo "ERROR: $1" >&2
fi
return 1
}
+13
View File
@@ -0,0 +1,13 @@
display_fatal() {
which tput &> /dev/null
if [[ "$?" == "0" ]] && [[ "$TERM" == "xterm" ]]; then
tput sgr0
tput setaf 1
echo "ERROR: $1" >&2
tput sgr0
else
echo "ERROR: $1" >&2
fi
exit 1
}
+10 -5
View File
@@ -1,7 +1,12 @@
display_message() {
# GREEN!
tput sgr0
tput setaf 2
echo "$1"
tput sgr0
which tput &> /dev/null
if [[ "$?" == "0" ]] && [[ "$TERM" == "xterm" ]]; then
# GREEN!
tput sgr0
tput setaf 2
echo "$1"
tput sgr0
else
echo "$1"
fi
}
+13
View File
@@ -0,0 +1,13 @@
display_warning() {
which tput &> /dev/null
if [[ "$?" == "0" ]] && [[ "$TERM" == "xterm" ]]; then
# YELLOW!
tput sgr0
tput setaf 3
echo "WARNING: $1"
tput sgr0
else
echo "$1"
fi
return 1
}
+11
View File
@@ -0,0 +1,11 @@
#!/usr/bin/env bash
LS_ERROR="GVM couldn't find ls"
GREP_ERROR="GVM couldn't find grep"
SORT_ERROR="GVM couldn't find sort"
HEAD_ERROR="GVM couldn't find head"
LS_PATH=`unalias ls &> /dev/null; which ls` || display_error "$LS_ERROR" || return 1
GREP_PATH=`unalias grep &> /dev/null; which grep` || display_error "$GREP_ERROR" || return 1
SORT_PATH=`unalias sort &> /dev/null; which sort` || display_error "$SORT_ERROR" || return 1
HEAD_PATH=`unalias head &> /dev/null; which head` || display_error "$HEAD_ERROR" || return 1
+1 -1
View File
@@ -1,4 +1,4 @@
#!/bin/bash
#!/usr/bin/env bash
for function in $GVM_ROOT/scripts/function/*; do
. $function
done
+7 -7
View File
@@ -1,20 +1,20 @@
#!/bin/bash
#!/usr/bin/env bash
. $GVM_ROOT/scripts/functions
[[ -d $GVM_ROOT/.git ]] || mv $GVM_ROOT/git.bak $GVM_ROOT/.git &> /dev/null ||
display_error "Couldn't find git info"
display_fatal "Couldn't find git info"
cd $GVM_ROOT && git checkout -f ||
display_error "Failed to clean install"
display_fatal "Failed to clean install"
if [[ -n $1 ]]; then
cd $GVM_ROOT && git checkout $1 -f ||
display_error "Failed to checkout $1 branch"
cd $GVM_ROOT && git checkout $1 -f ||
display_fatal "Failed to checkout $1 branch"
fi
cd $GVM_ROOT && git pull ||
display_error "Failed to update"
display_fatal "Failed to update"
mv $GVM_ROOT/.git $GVM_ROOT/git.bak ||
display_error "Couldn't backup git info"
display_fatal "Couldn't backup git info"
+33 -11
View File
@@ -1,15 +1,37 @@
#!/bin/bash
#!/usr/bin/env bash
. $GVM_ROOT/scripts/functions
[ -z `which hg` ] &&
display_error '* Could not find mercurial (try `sudo apt-get install mercurial`)'
[ -z `which ar` ] &&
display_error '* Could not find binutils (try `sudo apt-get install binutils (or binutils-multiarch)`)'
[ -z `which bison` ] &&
display_error '* Could not find bison (try `sudo apt-get install bison`)'
[ -z `which gcc` ] &&
display_error '* Could not find gcc (try `sudo apt-get install gcc`)'
[ -z `which make` ] &&
display_error '* Could not find make (try `sudo apt-get install make`)'
# Check for hg
which hg &> /dev/null ||
display_warning "Could not find mercurial
linux: apt-get install mercurial
mac: brew install mercurial
" || exit 1
# Check for ar
which ar &> /dev/null ||
display_warning "Could not find binutils
linux: apt-get install binutils
" || exit 1
# Check for bison
which bison &> /dev/null ||
display_warning "Could not find bison
linux: apt-get install bison
" || exit 1
# Check for gcc
which gcc &> /dev/null ||
display_warning "Could not find gcc
linux: apt-get install gcc
" || exit 1
# Check for make
which make &> /dev/null ||
display_warning "Could not find make
linux: apt-get install make
" || exit 1
# All good!
exit 0
+1
View File
@@ -15,6 +15,7 @@ mkdir -p $GVM_ROOT/environments > /dev/null 2>&1
export GVM_VERSION=`cat $GVM_ROOT/VERSION`
export PATH=$GVM_ROOT/bin:$PATH
export GVM_PATH_BACKUP=$PATH
[ -f $GVM_ROOT/environments/default ] && . $GVM_ROOT/environments/default
. $GVM_ROOT/scripts/env/gvm
+3
View File
@@ -0,0 +1,3 @@
export GVM_ROOT=@prefix@/gvm
. $GVM_ROOT/scripts/gvm-default
+131 -60
View File
@@ -1,70 +1,123 @@
#!/bin/bash
#!/usr/bin/env bash
. $GVM_ROOT/scripts/functions
function show_usage() {
echo "Usage: gvm install [version] [options]"
echo " -s, --source=SOURCE Install Go from specified source."
echo " -n, --name=NAME Override the default name for this version."
echo " -pb, --with-protobuf Install Go protocol buffers."
echo " -b, --with-build-tools Install package build tools."
echo " -h, --help Display this message."
}
read_command_line() {
VERSION=$1
if [[ "${VERSION:0:1}" != "-" ]]; then
shift
else
display_warning "Invalid version: $1"
show_usage
exit 1
fi
GO_SOURCE_URL=https://go.googlecode.com/hg/
for i in $*; do
case $i in
-s=*|--source=*)
GO_SOURCE_URL=`echo $i | sed 's/[-a-zA-Z0-9]*=//'`
;;
-n=*|--name=*)
GO_NAME=`echo $i | sed 's/[-a-zA-Z0-9]*=//'`
;;
-pb|--with-protobuf)
INSTALL_PB="true"
;;
-b|--with-build-tools)
INSTALL_BUILD_TOOLS="true"
;;
-h|--help)
show_usage
exit 0
;;
*)
display_warning "Invalid option $i"
show_usage
exit 65 # Bad arguments
;;
esac
done
}
download_source() {
GO_CACHE_PATH=$GVM_ROOT/archive/go
GO_SOURCE_URL=https://go.googlecode.com/hg/
[ -d $GO_CACHE_PATH ] && return
echo "Downloading Go source..."
[[ -d $GO_CACHE_PATH ]] && return
display_message "Downloading Go source..."
hg clone $GO_SOURCE_URL $GO_CACHE_PATH >> $GVM_ROOT/logs/go-download.log 2>&1 ||
display_error "Couldn't download Go source"
display_fatal "Couldn't download Go source"
}
check_tag() {
version=`hg tags -R $GO_CACHE_PATH | awk '{print $1}' | sort | grep $VERSION | head -n 1 | grep $VERSION`
version=`hg tags -R $GO_CACHE_PATH | awk '{print $1}' | $SORT_PATH | $GREP_PATH "$VERSION" | $HEAD_PATH -n 1 | $GREP_PATH "$VERSION"`
}
update_source() {
echo "Updating Go source..."
display_message "Updating Go source..."
hg pull -R $GO_CACHE_PATH >> $GVM_ROOT/logs/go-download.log 2>&1 ||
display_error "Couldn't get latest Go version info"
display_fatal "Couldn't get latest Go version info"
}
copy_source() {
hg clone -u $version $GO_CACHE_PATH $GO_INSTALL_ROOT >> $GVM_ROOT/logs/go-$version-install.log 2>&1 ||
display_error "Couldn't copy source to target folder"
hg clone -u $version $GO_CACHE_PATH $GO_INSTALL_ROOT >> $GVM_ROOT/logs/go-$GO_NAME-install.log 2>&1 ||
display_fatal "Couldn't copy source to target folder"
}
compile_go() {
echo " * Compiling..."
display_message " * Compiling..."
unset GOARCH && unset GOOS && unset GOPATH && unset GOBIN && unset GOROOT &&
export GOBIN=$GO_INSTALL_ROOT/bin &&
export PATH=$GOBIN:$PATH &&
export GOROOT=$GO_INSTALL_ROOT &&
cd $GO_INSTALL_ROOT/src && ./all.bash &> $GVM_ROOT/logs/go-$version-compile.log ||
(rm -rf $GO_INSTALL_ROOT && display_error "Failed to compile")
#cd $GO_INSTALL_ROOT/src && ./all.bash &> $GVM_ROOT/logs/go-$GO_NAME-compile.log ||
cd $GO_INSTALL_ROOT/src && ./make.bash &> $GVM_ROOT/logs/go-$GO_NAME-compile.log ||
(rm -rf $GO_INSTALL_ROOT && display_fatal "Failed to compile")
}
create_enviroment() {
new_env_file=$GVM_ROOT/environments/$version
new_env_file=$GVM_ROOT/environments/$GO_NAME
echo "export GVM_ROOT; GVM_ROOT=\"$GVM_ROOT\"" > $new_env_file
echo "export gvm_go_name; gvm_go_name=\"$version\"" >> $new_env_file
echo "export gvm_go_name; gvm_go_name=\"$GO_NAME\"" >> $new_env_file
echo "export gvm_pkgset_name; gvm_pkgset_name=\"global\"" >> $new_env_file
echo "export GOROOT; GOROOT=\"\$GVM_ROOT/gos/$version\"" >> $new_env_file
echo "export GOPATH; GOPATH=\"\$GVM_ROOT/pkgsets/$version/global\"" >> $new_env_file
echo "export PATH; PATH=\"\$GVM_ROOT/pkgsets/$version/global/bin:\$GVM_ROOT/gos/$version/bin:\$GVM_ROOT/bin:\$PATH\"" >> $new_env_file
echo "export GOROOT; GOROOT=\"\$GVM_ROOT/gos/$GO_NAME\"" >> $new_env_file
echo "export GOPATH; GOPATH=\"\$GVM_ROOT/pkgsets/$GO_NAME/global\"" >> $new_env_file
echo "export PATH; PATH=\"\$GVM_ROOT/pkgsets/$GO_NAME/global/bin:\$GVM_ROOT/gos/$GO_NAME/bin:\$GVM_ROOT/bin:\$PATH\"" >> $new_env_file
. $GVM_ROOT/scripts/env/use
gvm_use $version &> /dev/null
gvm_use $GO_NAME &> /dev/null ||
display_fatal "Failed to use installed version"
gvm pkgset create global
. $GVM_ROOT/scripts/env/pkgset-use
gvm_pkgset_use global &> /dev/null
unset GOPATH
}
install_go() {
GO_INSTALL_ROOT=$GVM_ROOT/gos/$version
trap 'rm -rf $GO_INSTALL_ROOT; display_error "Canceled!"' INT
GO_INSTALL_ROOT=$GVM_ROOT/gos/$GO_NAME
trap 'rm -rf $GO_INSTALL_ROOT; display_fatal "Canceled!"' INT
# Check for existing install
[ -d $GO_INSTALL_ROOT ] &&
display_error "Already installed!"
if [[ -d "$GO_INSTALL_ROOT" ]]; then
[[ -f "$GO_INSTALL_ROOT/manifest" ]] &&
display_fatal "Already installed!"
display_warning "Removing corrupt install..."
gvm uninstall $GO_NAME
fi
echo "Installing $version..."
if [[ "$version" != "$GO_NAME" ]]; then
display_message "Installing $version as $GO_NAME..."
else
display_message "Installing $version..."
fi
# Create the global package set folder
mkdir -p $GVM_ROOT/pkgsets/$version >> $GVM_ROOT/logs/go-$version-install.log 2>&1 ||
display_error "Couldn't create global package set folder"
mkdir -p $GVM_ROOT/pkgsets/$GO_NAME >> $GVM_ROOT/logs/go-$GO_NAME-install.log 2>&1 ||
display_fatal "Couldn't create global package set folder"
copy_source
compile_go
@@ -72,57 +125,75 @@ install_go() {
}
install_gpkg() {
echo " * Installing gpkg..."
goinstall github.com/moovweb/gvm/gpkg > /dev/null 2>&1
if [[ $? -ne 0 ]]; then
echo "Failed to install gpkg"
return 1
fi
display_message " * Installing gpkg..."
$GVM_GOINSTALL github.com/moovweb/gpkg > $GVM_ROOT/logs/$GO_NAME-gpkg.log 2>&1 || return 1
}
install_gb() {
if [[ "$version" == "release.r60.3" ]]; then
echo " * Installing gb..."
goinstall github.com/skelterjohn/go-gb/gb > /dev/null 2>&1
if [[ $? -ne 0 ]]; then
echo "Failed to install gb"
return 1
fi
fi
display_message " * Installing gb..."
$GVM_GOINSTALL github.com/jbussdieker/go-gb/gb > $GVM_ROOT/logs/$GO_NAME-gb.log 2>&1 || return 1
}
install_goprotobuf() {
if [[ "$version" == "release.r60.3" ]]; then
echo " * Installing goprotobuf..."
goinstall goprotobuf.googlecode.com/hg/proto > /dev/null 2>&1
which protoc &> /dev/null || display_warning "Could not find protocol buffer compiler
linux: apt-get install protobuf-compiler
mac: brew install protobuf
"
display_message " * Installing goprotobuf..."
if [[ "$GVM_GOINSTALL" == "goinstall" ]]; then
$GVM_GOINSTALL goprotobuf.googlecode.com/hg/proto > $GVM_ROOT/logs/$GO_NAME-pb-compiler.log 2>&1
if [[ $? -ne 0 ]]; then
echo "Failed to install goprotobuf"
display_warning "Failed to install goprotobuf"
return 1
fi
cd $GVM_ROOT/gos/$version/src/pkg/goprotobuf.googlecode.com/hg/compiler
make install > $GVM_ROOT/logs/$version-pb-compiler.log 2>&1
cd $GVM_ROOT/gos/$GO_NAME/src/pkg/goprotobuf.googlecode.com/hg/compiler
make install >> $GVM_ROOT/logs/$GO_NAME-pb-compiler.log 2>&1
if [[ $? -ne 0 ]]; then
echo "Failed to install goprotobuf compiler"
display_warning "Failed to install goprotobuf compiler"
return 1
fi
else
$GVM_GOINSTALL code.google.com/p/goprotobuf/proto > $GVM_ROOT/logs/$GO_NAME-pb-compiler.log 2>&1
if [[ $? -ne 0 ]]; then
display_warning "Failed to install goprotobuf"
return 1
fi
$GVM_GOINSTALL code.google.com/p/goprotobuf/protoc-gen-go > $GVM_ROOT/logs/$GO_NAME-pb-compiler.log 2>&1
if [[ $? -ne 0 ]]; then
display_warning "Failed to install goprotobuf compiler"
return 1
fi
fi
}
main() {
VERSION=$1
trap 'display_error "Canceled!"' INT
# GREEN!
tput sgr0
tput setaf 2
[ -z $VERSION ] && display_error "No version specified"
trap 'display_fatal "Canceled!"' INT
read_command_line $@
[[ "$VERSION" == "" ]] && display_fatal "No version specified"
download_source
check_tag || (update_source && check_tag) || display_error "Unrecognized Go version"
check_tag || (update_source && check_tag) || display_fatal "Unrecognized Go version"
if [[ "$GO_NAME" == "" ]]; then
GO_NAME=$version
fi
install_go
install_gpkg
install_gb
install_goprotobuf
GVM_GOINSTALL="goinstall"
which goinstall &> /dev/null ||
GVM_GOINSTALL="go get"
x="`hg tags -R ~/.gvm/archive/go`"; echo ${x#*b0819469a6df} | $GREP_PATH "$version " &> /dev/null
if [[ "$?" == "1" ]]; then
if [[ "$INSTALL_BUILD_TOOLS" == "true" ]]; then
install_gb || display_warning "Failed to install gb"
install_gpkg || display_warning "Failed to install gpkg"
fi
if [[ "$INSTALL_PB" == "true" ]]; then
install_goprotobuf
fi
fi
cd $GO_INSTALL_ROOT && find . > manifest
tput sgr0
}
main $@
+4 -4
View File
@@ -1,14 +1,14 @@
#!/bin/bash
#!/usr/bin/env bash
. $GVM_ROOT/scripts/functions
echo
display_message "gvm gos (installed)"
echo
if [ -d $GVM_ROOT/gos ]; then
if [[ -d $GVM_ROOT/gos ]]; then
if [[ "$gvm_go_name" != "" ]]; then
ls -1 $GVM_ROOT/gos | sed 's/^/ /g' | sed 's/^ '$gvm_go_name'/=> '$gvm_go_name'/g'
$LS_PATH -1 $GVM_ROOT/gos | sed 's/^/ /g' | sed 's/^ '$gvm_go_name\$'/=> '$gvm_go_name'/g'
else
ls -1 $GVM_ROOT/gos | sed 's/^/ /g'
$LS_PATH -1 $GVM_ROOT/gos | sed 's/^/ /g'
fi
fi
echo
+12 -4
View File
@@ -1,4 +1,4 @@
#!/bin/bash
#!/usr/bin/env bash
. $GVM_ROOT/scripts/functions
function show_usage() {
@@ -32,12 +32,20 @@ read_command_line $@
echo
display_message "gvm gos (available)"
echo
versions=`curl -s https://go.googlecode.com/hg/.hgtags | awk '{ print $2 }' | grep "$tag_filter" | sort`
versions=`curl -s https://go.googlecode.com/hg/.hgtags | awk '{ print $2 }' | $SORT_PATH`
if [[ $? -ne 0 ]]; then
display_error "Failed to get version list from Google"
display_fatal "Failed to get version list from Google"
fi
for version in $versions; do
echo " $version"
if [[ "$tag_filter" == "release" ]]; then
if [[ "${version:0:7}" == "release" ]]; then
echo " $version"
elif [[ "${version:0:3}" == "go1" ]]; then
echo " $version"
fi
else
echo " $version"
fi
done
echo
-36
View File
@@ -1,36 +0,0 @@
#!/bin/bash
. $GVM_ROOT/scripts/functions
[[ $gvm_go_name != "" ]] ||
display_error "No Go version selected"
[[ -d $GVM_ROOT/gos/$gvm_go_name ]] ||
display_error "Invalid or corrupt Go version"
[[ -d $GVM_ROOT/pkgsets/$gvm_go_name/$gvm_pkgset_name ]] ||
display_error "Missing package set folder"
command=$1
if [ -f $GVM_ROOT/scripts/pkg-$command ]; then
shift
$GVM_ROOT/scripts/pkg-$command $@
elif [[ -n $command ]]; then
display_error "Unrecognized command line argument: '$command'"
else
echo "= gvm pkg
* http://github.com/moovweb/gvm
== DESCRIPTION:
GVM Package is used to manage various Go packages
== Usage
gvm pkg Command
== Command
install - install go packages
uninstall - uninstall go packages
list - list installed go packages"
fi
-195
View File
@@ -1,195 +0,0 @@
#!/bin/bash
. $GVM_ROOT/scripts/functions
show_usage() {
echo "Usage: gvm pkg install Package [options]"
echo " -v, --version=VERSION Set the package version to install."
echo " -s, --source=SORUCE Specify the source for this package."
echo " --strict Only use installed packages."
echo " -a, --all Update all dependencies."
echo " -h, --help Display this message."
}
function read_command_line() {
[[ "$1" == "" ]] &&
display_error "Please specify package name"
# Get package name
package_name=$1
sources=`cat $GVM_ROOT/config/sources`
shift
for i in $*; do
case $i in
-v=*|--version=*)
version=`echo $i | sed 's/[-a-zA-Z0-9]*=//'`
;;
-s=*|--source=*)
sources=`echo $i | sed 's/[-a-zA-Z0-9]*=//' && echo $sources`
;;
-a|--all)
all_deps="true"
;;
-h|--help*)
show_usage
exit 0
;;
--strict)
strict="true"
;;
*)
echo "Invalid option $i"
show_usage
exit 65 # Bad arguments
;;
esac
done
gvm_go_path=$GVM_ROOT/pkgsets/$gvm_go_name/$gvm_pkgset_name
cache_dir=$GVM_ROOT/archive/package/$package_name
tmp_dir=$GVM_ROOT/tmp/$$
source_dir=$tmp_dir/$package_name/src/$package_name
build_dir=$tmp_dir/$package_name/build
}
function download_package() {
[ -d $cache_dir ] && return
#echo "Downloading $package_name..."
for source in $sources; do
git clone $source/$package_name $cache_dir > /dev/null 2>&1
if [ "$?" == "0" ]; then
echo $source > $cache_dir/GVM_SOURCE
return
fi
done
display_error "Could not find $package_name in any sources"
}
function update_package_cache() {
cd $cache_dir && git pull > /dev/null 2>&1 ||
display_error "Failed to update source"
}
function copy_tmp_source() {
rm -rf $source_dir
if [ "$version" != "" ]; then
git clone $cache_dir $source_dir > /dev/null 2>&1
cd $source_dir && git checkout $version > /dev/null 2>&1 ||
return 1
else
git clone $cache_dir $source_dir > /dev/null 2>&1
cd $source_dir
git describe --exact-match > /dev/null 2>&1
if [ "$?" == "0" ]; then
git_tag=`git describe --exact-match`
git_version=`echo $git_tag | awk '{ n=split($1,path,"_"); print path[n] }'`
if [ "$BUILD_NUMBER" == "" ]; then
BUILD_NUMBER=$git_version
fi
fi
fi
}
function setup_build_env() {
rm -rf $build_dir && mkdir -p $build_dir
copy_tmp_source
if [ "$?" != "0" ]; then
update_package_cache
copy_tmp_source ||
display_error "Invalid version"
fi
if [[ -f $source_dir/VERSION ]]; then
SOURCE_VERSION=`cat $source_dir/VERSION`
fi
if [[ -n $BUILD_NUMBER ]]; then
BUILD_NUMBER="$SOURCE_VERSION.$BUILD_NUMBER"
else
if [[ "$SOURCE_VERSION" != "" ]]; then
BUILD_NUMBER="$SOURCE_VERSION.src"
else
BUILD_NUMBER="src"
fi
fi
}
function install_dep() {
[[ "$strict" == "true" ]] && display_error "Missing dependancy ($1) and strict mode is set"
[[ "$source" == "." ]] && passthrough_options="--source=. "$passthrough_options
[[ "$all_deps" == "true" ]] && passthrough_options="--all "$passthrough_options
gvm pkg install $1 $passthrough_options ||
display_error "Failed to install dependency $1"
}
function load_dep() {
if [[ "$all_deps" == "true" ]]; then
install_dep $1
fi
CUR_PKG=$gvm_go_path/pkg.gvm/$1/current
if [ -e "$CUR_PKG/BUILD_VERSION" ]; then
echo "pkg $1 `cat $CUR_PKG/BUILD_VERSION`" >> $build_dir/manifest
else
install_dep $1
fi
cp -rf $CUR_PKG/pkg $build_dir
}
function check_deps() {
export GOPATH=$build_dir
echo ":source `cat $cache_dir/GVM_SOURCE`" >> $build_dir/manifest
if [ -f "$source_dir/Package.gvm" ]; then
for line in `cat $source_dir/Package.gvm | grep ^pkg | awk '{ print $2 }'`; do
load_dep $line
done
fi
echo ":complete" >> $build_dir/manifest
}
function copy_source() {
mkdir -p $gvm_go_path/pkg.gvm/$package_name/$BUILD_NUMBER
cp -rf $source_dir $gvm_go_path/pkg.gvm/$package_name/$BUILD_NUMBER/
}
function build_package() {
echo "Installing $package_name-$BUILD_NUMBER..."
echo "$BUILD_NUMBER" > $build_dir/BUILD_VERSION
cd $source_dir && gvmake > $build_dir/build.log 2>&1
if [ $? -ne 0 ]; then
echo "ERROR: Failed to build"
cat "$build_dir/build.log"
exit 1
fi
}
function install_package() {
mkdir -p $gvm_go_path/pkg.gvm/$package_name/$BUILD_NUMBER &&
cp -r $build_dir/* $gvm_go_path/pkg.gvm/$package_name/$BUILD_NUMBER &&
rm -f $gvm_go_path/pkg.gvm/$package_name/current &&
ln -s $gvm_go_path/pkg.gvm/$package_name/$BUILD_NUMBER $gvm_go_path/pkg.gvm/$package_name/current &&
if [ $? -ne 0 ]; then
echo "ERROR: Failed to install"
exit 1
fi
if [ -d $build_dir/bin ]; then
echo " * Installing binaries"
mkdir -p $gvm_go_path/bin &&
cp -f $build_dir/bin/* $gvm_go_path/bin/
fi
}
function cleanup() {
rm -rf $tmp_dir
}
read_command_line $@
download_package
setup_build_env
check_deps
copy_source
build_package
install_package
cleanup
-39
View File
@@ -1,39 +0,0 @@
#!/bin/bash
. $GVM_ROOT/scripts/functions
echo "
gvm packages $gvm_go_name@$gvm_pkgset_name"
echo
package_folder=$GVM_ROOT/pkgsets/$gvm_go_name/$gvm_pkgset_name
for package in $package_folder/pkg.gvm/*; do
if [ $package == "$package_folder/pkg.gvm/*" ]; then
break
fi
package_name=`echo $package | awk '{ n=split($1,path,"/"); print path[n] }'`
output=$package_name" ("
first=true
for version in $package/*; do
version=`echo $version | awk '{ n=split($1,path,"/"); print path[n] }'`
if [ "$version" != "current" ]; then
if [ $first == true ]; then
first=false
else
output=$output", "
fi
version=`echo $version | awk '{ n=split($1,path,"/"); print path[n] }'`
output=$output$version
fi
done
output=$output")"
echo $output
done
if [ -f $package_folder/goinstall.log ]; then
echo
echo "Installing via goinstall"
echo
cat $package_folder/goinstall.log
fi
echo
-31
View File
@@ -1,31 +0,0 @@
#!/bin/bash
. $GVM_ROOT/scripts/functions
[[ "$1" == "" ]] &&
display_error "Please specify package name"
gvm_go_path=$GVM_ROOT/pkgsets/$gvm_go_name/$gvm_pkgset_name
UNINSTALL_ROOT=$gvm_go_path/pkg.gvm/$1
if [[ ! -d $UNINSTALL_ROOT ]]; then
echo "ERROR: Invalid package name"
exit 1
fi
if [[ "$2" != "" ]]; then
UNINSTALL_ROOT=$UNINSTALL_ROOT/$2
fi
if [[ -d $UNINSTALL_ROOT ]]; then
rm -rf $UNINSTALL_ROOT
else
echo "ERROR: Invalid package version"
exit 1
fi
if [[ "$4" != "" ]]; then
echo "Uninstalled $1 version $2"
else
echo "Uninstalled $1"
fi
-20
View File
@@ -1,20 +0,0 @@
#!/bin/bash
. $GVM_ROOT/scripts/functions
[[ "$1" == "" ]] &&
display_error "Please specify package name"
[[ ! -d $GVM_ROOT/archive/package/$1 ]] &&
display_error "Invalid package"
cd $GVM_ROOT/archive/package/$1
git pull &> /dev/null
if [ "$?" == "1" ]; then
echo "Changes!"
else
echo "No changes"
fi
#cd git pull
#gvm_go_path=$GVM_ROOT/pkgsets/$gvm_go_name/$gvm_pkgset_name
+6 -6
View File
@@ -1,19 +1,19 @@
#!/bin/bash
#!/usr/bin/env bash
. $GVM_ROOT/scripts/functions
[[ $gvm_go_name != "" ]] ||
display_error "No Go version selected"
display_fatal "No Go version selected"
[[ -d $GVM_ROOT/gos/$gvm_go_name ]] ||
display_error "Invalid or corrupt Go version"
display_fatal "Invalid or corrupt Go version"
[[ -d $GVM_ROOT/pkgsets/$gvm_go_name ]] ||
display_error "Missing package set folder for this Go version"
display_fatal "Missing package set folder for this Go version"
command=$1
if [ -f $GVM_ROOT/scripts/pkgset-$command ]; then
if [[ -f $GVM_ROOT/scripts/pkgset-$command ]]; then
shift
$GVM_ROOT/scripts/pkgset-$command $@
elif [[ -n $command ]]; then
display_error "Unrecognized command line argument: '$command'"
display_fatal "Unrecognized command line argument: '$command'"
else
echo "= gvm pkgset
+10 -10
View File
@@ -1,20 +1,20 @@
#!/bin/bash
#!/usr/bin/env bash
. $GVM_ROOT/scripts/functions
[[ $1 != "" ]] ||
display_error "Please specifiy the name"
display_fatal "Please specifiy the name"
[[ ! -f "$GVM_ROOT/environments/$gvm_go_name@$1" ]] ||
display_error "Packageset already exists!"
display_fatal "Packageset already exists!"
mkdir -p $GVM_ROOT/pkgsets/$gvm_go_name/$1 ||
display_error "Could not create folder"
display_fatal "Could not create folder"
cp $GVM_ROOT/environments/$gvm_go_name $GVM_ROOT/environments/$gvm_go_name@$1 ||
display_error "Could copy environment"
display_fatal "Could copy environment"
echo "export gvm_pkgset_name=\"$1\"" >> $GVM_ROOT/environments/$gvm_go_name@$1 ||
display_error "Could not extend environment"
echo "export GOPATH; GOPATH=\"$GVM_ROOT/pkgsets/release.r60.3/$1:\$GOPATH\"" >> $GVM_ROOT/environments/$gvm_go_name@$1 ||
display_error "Could not extend environment"
echo "export PATH; PATH=\"$GVM_ROOT/pkgsets/release.r60.3/$1/bin:\$PATH\"" >> $GVM_ROOT/environments/$gvm_go_name@$1 ||
display_error "Could not extend environment"
display_fatal "Could not extend environment"
echo "export GOPATH; GOPATH=\"$GVM_ROOT/pkgsets/$gvm_go_name/$1:\$GOPATH\"" >> $GVM_ROOT/environments/$gvm_go_name@$1 ||
display_fatal "Could not extend environment"
echo "export PATH; PATH=\"$GVM_ROOT/pkgsets/$gvm_go_name/$1/bin:\$PATH\"" >> $GVM_ROOT/environments/$gvm_go_name@$1 ||
display_fatal "Could not extend environment"
+6 -6
View File
@@ -1,18 +1,18 @@
#!/bin/bash
#!/usr/bin/env bash
. $GVM_ROOT/scripts/functions
[[ $gvm_go_name != "" ]] ||
display_error "No Go version selected"
display_fatal "No Go version selected"
[[ $1 != "" ]] ||
display_error "Please specifiy the name"
display_fatal "Please specifiy the name"
[[ -d $GVM_ROOT/pkgsets/$gvm_go_name/$1 ]] ||
display_error "Packageset doesn't exist!"
display_fatal "Packageset doesn't exist!"
rm -rf $GVM_ROOT/pkgsets/$gvm_go_name/$1 ||
display_error "Could not delete package set"
display_fatal "Could not delete package set"
rm -rf $GVM_ROOT/environments/$gvm_go_name@$1 ||
display_error "Could not delete package set"
display_fatal "Could not delete package set"
+4 -4
View File
@@ -1,8 +1,8 @@
#!/bin/bash
#!/usr/bin/env bash
. $GVM_ROOT/scripts/functions
[[ $gvm_pkgset_name != "" ]] ||
display_error "No Package set selected"
[[ $gvm_pkgset_name != "" ]] ||
display_fatal "No Package set selected"
rm -rf $GVM_ROOT/pkgsets/$gvm_go_name/$gvm_pkgset_name/* ||
display_error "Could not delete package set files"
display_fatal "Could not delete package set files"
+17 -10
View File
@@ -1,13 +1,20 @@
#!/bin/bash
echo "
gvm go package sets ($gvm_go_name)
"
if [ -d $GVM_ROOT/pkgsets ]; then
if [[ $gvm_pkgset_name == "" ]]; then
ls -1 $GVM_ROOT/pkgsets/$gvm_go_name | sed 's/^/ /g'
else
ls -1 $GVM_ROOT/pkgsets/$gvm_go_name | sed 's/^/ /g' | sed 's/^ '$gvm_pkgset_name'/=> '$gvm_pkgset_name'/g'
fi
#!/usr/bin/env bash
. $GVM_ROOT/scripts/functions
echo
display_message "gvm go package sets ($gvm_go_name)"
echo
if [[ -d $GVM_ROOT/pkgsets/$gvm_go_name ]]; then
for cur_dir in $GVM_ROOT/pkgsets/$gvm_go_name/*; do
[[ "$cur_dir" == "$GVM_ROOT/pkgsets/$gvm_go_name/*" ]] && exit
pkgset=`basename $cur_dir`
if [[ "$gvm_pkgset_name" == "$pkgset" ]]; then
echo "=> $pkgset"
else
echo " $pkgset"
fi
done
fi
echo
-6
View File
@@ -1,6 +0,0 @@
#!/bin/bash
. $GVM_ROOT/scripts/functions
display_message "*** CURRENT SOURCES ***"
echo
cat $GVM_ROOT/config/sources
+15
View File
@@ -0,0 +1,15 @@
#!/usr/bin/env bash
. $GVM_ROOT/scripts/functions/tools
echo $1 | sed -n -e '/_.*_/ p' | $GREP_PATH "_" &> /dev/null
if [ "$?" == "0" ]; then
version=`echo $1 | sed 's/_\(.*\)_/\1/'`
if [[ ! -f $GVM_ROOT/pkgsets/$gvm_go_name/$gvm_pkgset_name/pkg.gvm/{{package_name}}/$version/bin/{{binary_name}} ]]; then
echo "GVM: Invalid version"
exit 1
fi
shift
$GVM_ROOT/pkgsets/$gvm_go_name/$gvm_pkgset_name/pkg.gvm/{{package_name}}/$version/bin/{{binary_name}} $@
else
$GVM_ROOT/pkgsets/$gvm_go_name/$gvm_pkgset_name/pkg.gvm/{{package_name}}/current/bin/{{binary_name}} $@
fi
+15 -12
View File
@@ -1,19 +1,22 @@
#!/bin/bash
#!/usr/bin/env bash
. $GVM_ROOT/scripts/functions
[[ "$1" == "" ]] &&
display_error "Please specifiy the version"
display_fatal "Please specifiy the version"
fuzzy_match=`ls $GVM_ROOT/gos | sort | grep "$1" | head -n 1 | grep "$1"` ||
display_error "Invalid version $1"
fuzzy_match=`$LS_PATH $GVM_ROOT/gos | $SORT_PATH | $GREP_PATH "$1" | $HEAD_PATH -n 1 | $GREP_PATH "$1"` ||
display_fatal "Invalid version $1"
if [ -d $GVM_ROOT/gos/$fuzzy_match ]; then
rm -rf $GVM_ROOT/gos/$fuzzy_match
rm -rf $GVM_ROOT/pkgsets/$fuzzy_match
rm -f $GVM_ROOT/environments/$fuzzy_match
rm -f "$GVM_ROOT/environments/$fuzzy_match@"*
echo "Uninstalled version $fuzzy_match"
if [[ -d $GVM_ROOT/gos/$fuzzy_match ]]; then
rm -rf $GVM_ROOT/pkgsets/$fuzzy_match &> /dev/null ||
display_fatal "Couldn't remove pkgsets"
rm -f $GVM_ROOT/environments/$fuzzy_match &> /dev/null ||
display_fatal "Couldn't remove environment files"
rm -f "$GVM_ROOT/environments/$fuzzy_match@"* &> /dev/null ||
display_fatal "Couldn't remove pkgset environment files"
rm -rf $GVM_ROOT/gos/$fuzzy_match &> /dev/null ||
display_fatal "Couldn't remove Go folder"
display_message "Uninstalled version $fuzzy_match"
else
display_error "Invalid version"
display_fatal "Invalid version"
fi
Executable
+9
View File
@@ -0,0 +1,9 @@
#!/usr/bin/env bash
. $GVM_ROOT/scripts/functions
cd $GVM_ROOT/archive/go &> /dev/null ||
display_fatal "Failed to find local Go source"
cd $GVM_ROOT/archive/go && hg pull ||
display_fatal "Failed to update"
+4
View File
@@ -0,0 +1,4 @@
#!/usr/bin/env bash -ex
TEST_OUTPUT=`gvm version`
[ "$TEST_OUTPUT" != "" ]
echo "Success!"